const PZTab = (props) => {
  const tabs = Array.from(Object.keys(props.pzTabs), k => props.pzTabs[k]);
  let sorted_tabs = tabs.sort(function (a, b) {
    return a.sort_id - b.sort_id;
  })
  return (
    <div className="pz-custom-item-content">
      {
        sorted_tabs.map((pzTab, index) => {
          //let pzTab = props.pzTabs[pzTabKey];
          const pzDisplayStyle = { 1: 'square', 2: 'circle', 3: 'radio', 4: 'checkbox', 5: 'select', 6: 'input' };
          const pzTabStyle = (pzTab.tab_style) ? JSON.parse(pzTab.tab_style) : '';
          const displayType = (pzDisplayStyle[pzTabStyle.display]) ? pzDisplayStyle[pzTabStyle.display] : 'square';

          let pzSubDisplay = {};
          let pzSubTabDetail = {};
          let subtabs = Object.keys(props.pzCustomizer.subtabs).length > 0 ? props.pzCustomizer.subtabs[pzTab.promize_tab_id] : {}
          let sub_tabs = subtabs && Object.keys(props.pzCustomizer.subtabs).length > 0 ? Array.from(Object.keys(subtabs), k => subtabs[k]) : [];
          let sorted_sub_tabs = sub_tabs.length > 0 ? sub_tabs.sort(function (a, b) {
            return a.sort_id - b.sort_id;
          }) : []
          
          sorted_sub_tabs && sorted_sub_tabs.length > 0 && sorted_sub_tabs.map((tabKey, index) => {
            if (Object.keys(props.pzActiveOptions).length > 0) {
              return Object.keys(props.pzActiveOptions).map((active_Option) => {
                if (parseInt(tabKey.parent_option_id) == parseInt(props.pzActiveOptions[active_Option][1])) {
                  pzSubDisplay = JSON.parse(props.pzTabs[tabKey.child_tab_id].additional_data);
                  pzSubTabDetail = props.pzTabs[tabKey.child_tab_id];
                }
              })
            }
          });
          if (pzTab.is_sub_tab == 1 || props.pzHideTabs.includes(pzTab.promize_tab_id)) {
            return ''
          }

          return (
            <React.Fragment>
              <div key={index} className={(props.pzActiveTab[pzTab.promize_section_id] == pzTab.promize_tab_id && props.pzActiveSection == pzTab.promize_section_id) ? `pz-custom-items open` : (props.pzActiveSection != pzTab.promize_section_id ? `pz-custom-items hide`  :`pz-custom-items`)}>
                <div className="pz-custom-item-header" onClick={(e) => { e.preventDefault(), props.HomeComponent.pzSetSelectedTab(pzTab.promize_tab_id, pzTab) }}>
                  {
                    pzTab.tab_icon &&
                    <div className="pz-tab-icon">
                      <img src={props.pzImgUrl.concat(pzTab.tab_icon.replace(props.pzReplaceImg, ''))} style={{ width: 20, height: 20 }} />
                    </div>
                  }
                  <h4 className="pz-item-header">
                    <span className="pz-item-title-text">{pzTab.tab_name}</span>{pzTab.tab_name == "ADD A SHAPE" ? <span className="del_shapes" onClick={() =>{props.onClickRemoveOptions(pzTab)}} style={{ display: "inline-block" }}><i className="fa fa-trash" aria-hidden="true"></i></span> : null}
                  </h4>
                </div>
                <div className={"pz-custom-item-body"}>
                  {pzTab.tab_description ?
                  <p class="pz-custom-item-description" dangerouslySetInnerHTML={{ __html: pzTab.tab_description }}>
                  {/* {pzTab.tab_description} */}
                  </p> : ''
                  }
                  {
                    displayType === 'input' && <div>
                      <input type="text" value={props.pzActiveOptions[pzTab.promize_tab_id]} onChange={(e) =>{props.onChangeHandler(e, pzTab)}}></input>
                    </div>
                  }
                  <PromizeAttribute pzTab={pzTab} pzTabType="Tab" {...props} />
                  {sorted_sub_tabs && sorted_sub_tabs.length > 0 && sorted_sub_tabs.map((tabKey, index) => {
                    if (tabKey.parent_tab_id == pzTab.promize_tab_id) {
                      return <PromizeSubTab key={index} pzSubTabDetail={props.pzTabs[tabKey.child_tab_id]} {...props} />
                    }
                  })
                  }
                  {(pzSubDisplay && pzSubDisplay.inherit && pzSubDisplay.inherit == 1) && <PromizeSubTab pzSubTabDetail={pzSubTabDetail} {...props} />}
                </div>
              </div>
              {(pzSubDisplay && pzSubDisplay.inherit && pzSubDisplay.inherit == 2) && <PromizeSubTab pzSubTabDetail={pzSubTabDetail} {...props} />}
            </React.Fragment>
          )
        })
      }
    </div>
  );
}